// tempus 2000.11

//
// tempus, version 2000.11, (c) Copyright 1995-2000, MZA Associates Corporation
// Generated on: Fri Sep 07 15:33:09 MDT 2001
//

#include "tempus.h"
#include "Recorders.h"
#include "FileSys.h"
#include "VectorFunctions.h"
#include "TutE.h"

#ifndef NO_TEMPUS_SMF_MONITOR
#include "TempusStatusSMF.h"
#endif

main(int argc, char* argv[])
{
   double stopTime = 0.020;
   int ___ierr;
   char *___outfile="TutERunsetC.trf";
   float  gain_values[1] = {1.0};
   Array<float>  gain_values_array(1);
   for(int mli_gain_values_0 = 0; mli_gain_values_0 < 1; mli_gain_values_0++)
      gain_values_array(mli_gain_values_0) = gain_values[mli_gain_values_0];

   float  alpha = 0.0;
   int  nscreen = 5;
   float  hPlatform = 2400;
   float  hTarget = 2400;
   float  target_range = 50000;
   float  tel_focus_range = target_range;
   float  tel_diam = 0.75;
   float  hel_wavelength = 1.0e-6;
   float  ptsc_wavelength = hel_wavelength;
   float  ptsc_x = 0.5;
   float  ptsc_y = 0.0;
   AcsAtmSpec  AtmSpec = AcsAtmSpec(ptsc_wavelength,nscreen,alpha,hPlatform,hTarget,target_range);
   char   ___AtmSpecStr[159];
   sprintf(___AtmSpecStr,"(AcsAtmSpec)  AcsAtmSpec(ptsc_wavelength,nscreen,alpha,hPlatform,hTarget,target_range)\n\0");
   float  x_wind = 10.0;
   float  y_wind = 0.0;
   int  propnxy = 256;
   float  propdxy = 0.02;
   int  tbd_nxy = 100;
   float  tbd_dxy = 0.01;
   int  img_nxy = 100;
   float  img_dxy = tbd_dxy/target_range;
   float  bsm_timeConstant = 1.0e-3;
   ParamSet pssetC;
   int rand_index = 0;
   writeParam(pssetC, "rand_index", LOOP, &rand_index);
   int gain_index = 0;
   writeParam(pssetC, "gain_index", LOOP, &gain_index);
   writeParam(pssetC, "stopTime", DOUBLE, &stopTime);
   char *___trfname;
   char *___filename;
   int ___totalRuns, ___currentRun;
   int ___newDataFile = 0;
   ___totalRuns = 1;
   ___currentRun = 1;

#ifndef NO_TEMPUS_SMF_MONITOR
   char *___smfname;
   parseName(argc, argv, ___outfile, &___smfname, &___trfname, stopTime);
   TempusStatusSMFWriter ___smfWriter(___smfname, ___trfname, "",___totalRuns);
   setCurrentSMF(&___smfWriter);
#else
   char *___tmpbuf;
   parseName(argc, argv, ___outfile, &___tmpbuf, stopTime);
   ___trfname = checkName(___tmpbuf);
   delete [] ___tmpbuf;
#endif

   Universe usetC("usetC");
   Trace ___trace("runset rsetC:");  ___trace.newline();
   for (rand_index=0; rand_index < 1; rand_index++)
   {
      Trace ___trace("loop rand_index = ");  ___trace.out() << rand_index; ___trace.newline();
      int  AtmSeed = seedSequence(-123456789,rand_index);
      for (gain_index=0; gain_index < 1; gain_index++)
      {
         Universe usetC("usetC");

#ifndef NO_TEMPUS_SMF_MONITOR
         ___smfWriter.Pausing();
#endif

         Trace ___trace("loop gain_index = ");  ___trace.out() << gain_index; ___trace.newline();
         float  trk_gain = gain_values[gain_index];
         checkLimit(&___newDataFile,  ___trfname, ___outfile, &___currentRun, &___totalRuns);
         if(___newDataFile < 0) {
            delete [] ___filename;
            ___filename = checkName(___trfname);
            ___newDataFile = 0;
            TK_start_timing = TK_timer.cpuTime();
         }

#ifndef NO_TEMPUS_SMF_MONITOR
         ___smfWriter.startNewRun(___currentRun, stopTime);
#endif

         TutE setC(NULL, "setC",
                    tel_focus_range,
                    tel_diam,
                    hel_wavelength,
                    ptsc_wavelength,
                    ptsc_x,
                    ptsc_y,
                    AtmSpec,
                    AtmSeed,
                    x_wind,
                    y_wind,
                    propnxy,
                    propdxy,
                    tbd_nxy,
                    tbd_dxy,
                    img_nxy,
                    img_dxy,
                    bsm_timeConstant,
                    trk_gain);

         // External Inputs
         // Connect external inputs
         writeParam(pssetC, "rand_index", LOOP, &rand_index);
         writeParam(pssetC, "gain_index", LOOP, &gain_index);
         writeParam(pssetC, "gain_values_array", ARRAY_FLOAT, &gain_values_array);
         writeParam(pssetC, "alpha", FLOAT, &alpha);
         writeParam(pssetC, "nscreen", INT, &nscreen);
         writeParam(pssetC, "hPlatform", FLOAT, &hPlatform);
         writeParam(pssetC, "hTarget", FLOAT, &hTarget);
         writeParam(pssetC, "target_range", FLOAT, &target_range);
         writeParam(pssetC, "tel_focus_range", FLOAT, &tel_focus_range);
         writeParam(pssetC, "tel_diam", FLOAT, &tel_diam);
         writeParam(pssetC, "hel_wavelength", FLOAT, &hel_wavelength);
         writeParam(pssetC, "ptsc_wavelength", FLOAT, &ptsc_wavelength);
         writeParam(pssetC, "ptsc_x", FLOAT, &ptsc_x);
         writeParam(pssetC, "ptsc_y", FLOAT, &ptsc_y);
         writeParam(pssetC, "AtmSpec", OTHER_TYPE, ___AtmSpecStr);
         writeParam(pssetC, "AtmSeed", INT, &AtmSeed);
         writeParam(pssetC, "x_wind", FLOAT, &x_wind);
         writeParam(pssetC, "y_wind", FLOAT, &y_wind);
         writeParam(pssetC, "propnxy", INT, &propnxy);
         writeParam(pssetC, "propdxy", FLOAT, &propdxy);
         writeParam(pssetC, "tbd_nxy", INT, &tbd_nxy);
         writeParam(pssetC, "tbd_dxy", FLOAT, &tbd_dxy);
         writeParam(pssetC, "img_nxy", INT, &img_nxy);
         writeParam(pssetC, "img_dxy", FLOAT, &img_dxy);
         writeParam(pssetC, "bsm_timeConstant", FLOAT, &bsm_timeConstant);
         writeParam(pssetC, "trk_gain", FLOAT, &trk_gain);

         RecorderFile rfsetC(NULL, "rfsetC", ___trfname, ParamSet_stringify(pssetC), pssetC);
         GridRecorder<float> rfsetC1(NULL, "rfsetC1", "setC.targetboard.integrated_intensity", "Grid<float>", "Integrated intensity", true, (float)0.0, 0.0);
         rfsetC1.dr <<= rfsetC.dr;
         rfsetC1.i <<= setC.targetboard.integrated_intensity;
         GridRecorder<float> rfsetC2(NULL, "rfsetC2", "setC.camera.fpaImage", "Grid<float>", "the image formed at focal plane, integrated over each exposure interval", true, (float)0.0, 0.0);
         rfsetC2.dr <<= rfsetC.dr;
         rfsetC2.i <<= setC.camera.fpaImage;
         VectorRecorder<float> rfsetC3(NULL, "rfsetC3", "setC.BSM.measuredTilts", "Vector<float>", "measured tilts (radians) (from an ideal pickoff sensor)", true, (float)0.0, 0.0);
         rfsetC3.dr <<= rfsetC.dr;
         rfsetC3.i <<= setC.BSM.measuredTilts;
         floatRecorder rfsetC4(NULL, "rfsetC4", "setC.trk_centroid.x", "float", "X-coordinate of centroid (m)", true, (float)0.0, 0.0);
         rfsetC4.dr <<= rfsetC.dr;
         rfsetC4.i <<= setC.trk_centroid.x;
         floatRecorder rfsetC5(NULL, "rfsetC5", "setC.trk_centroid.y", "float", "Y-coordinate of centroid (m)", true, (float)0.0, 0.0);
         rfsetC5.dr <<= rfsetC.dr;
         rfsetC5.i <<= setC.trk_centroid.y;
         floatRecorder rfsetC6(NULL, "rfsetC6", "setC.tbd_centroid.x", "float", "X-coordinate of centroid (m)", true, (float)0.0, 0.0);
         rfsetC6.dr <<= rfsetC.dr;
         rfsetC6.i <<= setC.tbd_centroid.x;
         floatRecorder rfsetC7(NULL, "rfsetC7", "setC.tbd_centroid.y", "float", "Y-coordinate of centroid (m)", true, (float)0.0, 0.0);
         rfsetC7.dr <<= rfsetC.dr;
         rfsetC7.i <<= setC.tbd_centroid.y;


#ifndef NO_TEMPUS_SMF_MONITOR
         advanceTime(stopTime, ___smfWriter);
         ___smfWriter.Pausing();
#else
         advanceTime(stopTime);
#endif

   ___currentRun++;
      }
   }

#ifndef NO_TEMPUS_SMF_MONITOR
   TempusStatusSMFDynamic* ___smfDynamic = ___smfWriter.getDynamicPtr();
   ___smfDynamic->iRun = ___totalRuns + 1;
#endif

   return(0);
}
