// tempus 2000.11

//
// tempus, version 2000.11, (c) Copyright 1995-2000, MZA Associates Corporation
// Generated on: Thu Jul 19 07:34:55 MDT 2001
//

#include "mliConv.h"
#include "mliSystem.h"
#include "TutG.h"

#include "VectorFunctions.h"
#include "MathematicalConstants.h"
#include "matrixIO.h"
#include "PhysicalConstants.h"
const int numParams   = 31;
const int numRecords = 20;
const char* sysRecordItems[numRecords] = {
   "targetboard.integrated_intensity  Grid<float>  true  (float)0.0  0.0",
   "uw.power  float  true 0 0",
   "trk_camera.fpaImage  Grid<float>  true  (float)0.0  0.0",
   "BSM.measuredTilts  Vector<float>  true 0 0",
   "BSM.delay.delayedScalar  float  true 0 0",
   "BSM.delay.delayedVector  Vector<float>  true 0 0",
   "trk_centroid.x  float  true  (float)0.0  0.0",
   "trk_centroid.y  float  true 0 0",
   "trk_centroid.v  Vector<float>  true 0 0",
   "summer.sum  Vector<float>  true 0 0",
   "img_camera.fpaImage  Grid<float>  true  (float)0.0  0.0",
   "incoherentreflector.illumination  Grid<float>  true  (float)0.0  0.0",
   "incoherentreflector.signature  Grid<float>  true  (float)0.0  0.0",
   "uw2.power  float  true 0 0",
   "img_centroid.x  float  true  (float)0.0  0.0",
   "img_centroid.y  float  true 0 0",
   "img_centroid.v  Vector<float>  true 0 0",
   "tbd_centroid.x  float  true  (float)0.0  0.0",
   "tbd_centroid.y  float  true 0 0",
   "tbd_centroid.v  Vector<float>  true 0 0"
};

const int numDefRecords = 8;
const char* sysDefRecordItems[numDefRecords] = {
   "targetboard.integrated_intensity  Grid<float>  true  (float)0.0  0.0",
   "trk_camera.fpaImage  Grid<float>  true  (float)0.0  0.0",
   "trk_centroid.x  float  true  (float)0.0  0.0",
   "img_camera.fpaImage  Grid<float>  true  (float)0.0  0.0",
   "incoherentreflector.illumination  Grid<float>  true  (float)0.0  0.0",
   "incoherentreflector.signature  Grid<float>  true  (float)0.0  0.0",
   "img_centroid.x  float  true  (float)0.0  0.0",
   "tbd_centroid.x  float  true  (float)0.0  0.0"
};
mxArray* mliLoadRecords()
{
   mxArray* a = mxCreateCellMatrix(1, numRecords);
   for(int ic=0; ic < numRecords; ic++) {
      mxSetCell(a, ic, mxCreateString(sysRecordItems[ic]));
   }
   return a;
}

mxArray* mliLoadDefRecords()
{
   mxArray* a = mxCreateCellMatrix(1, numDefRecords);
   for(int ic=0; ic < numDefRecords; ic++) {
      mxSetCell(a, ic, mxCreateString(sysDefRecordItems[ic]));
   }
   return a;
}

const char* sysParams[numParams] = {
   "rand_index",
   "gain_index",
   "gain_values",
   "mapfiles",
   "alpha",
   "nscreen",
   "hPlatform",
   "hTarget",
   "target_range",
   "tel_focus_range",
   "tel_diam",
   "hel_wavelength",
   "ptsc_wavelength",
   "targ_wavelength",
   "ptsc_x",
   "ptsc_y",
   "{AtmSpec}",
   "AtmSeed",
   "x_wind",
   "y_wind",
   "propnxy",
   "propdxy",
   "tbd_nxy",
   "tbd_dxy",
   "img_nxy",
   "img_dxy",
   "bsm_timeConstant",
   "trk_gain",
   "num_speck",
   "SpeckSeed",
   "{reflectance}"
};

const char* sysParamsVals[numParams] = {
   "int  rand_index  $loop(1)",
   "int  gain_index  $loop(2)",
   "float  gain_values  {0.0,1.0}",
   "char*  mapfiles  \"./targets.mat/disc50\"",
   "float  alpha  1.0",
   "int  nscreen  5",
   "float  hPlatform  2400",
   "float  hTarget  2400",
   "float  target_range  50000",
   "float  tel_focus_range  target_range",
   "float  tel_diam  0.75",
   "float  hel_wavelength  1.0e-6",
   "float  ptsc_wavelength  hel_wavelength",
   "float  targ_wavelength  hel_wavelength+0.001e-6",
   "float  ptsc_x  0.0",
   "float  ptsc_y  0.0",
   "{AcsAtmSpec  AtmSpec  AcsAtmSpec(ptsc_wavelength,nscreen,alpha,hPlatform,hTarget,target_range)}",
   "int  AtmSeed  seedSequence(-123456789,rand_index)",
   "float  x_wind  10.0",
   "float  y_wind  0.0",
   "int  propnxy  256",
   "float  propdxy  0.02",
   "int  tbd_nxy  100",
   "float  tbd_dxy  0.01",
   "int  img_nxy  100",
   "float  img_dxy  tbd_dxy/target_range",
   "float  bsm_timeConstant  1.0e-6",
   "float  trk_gain  gain_values[gain_index]",
   "int  num_speck  8",
   "int  SpeckSeed  seedSequence(-123456789+100000,rand_index)",
   "{Grid<float>&  reflectance  matrixLoad(mapfiles,reflectance,0,0)}"
};

/* MEX Functionhandlers */

mxArray* mliLoadParams()
{
   mxArray* a = mxCreateStructMatrix(1, 1, numParams, sysParams);

   mxSetField(a, 0, sysParams[0], mxCreateString(sysParamsVals[0]));
   mxSetField(a, 0, sysParams[1], mxCreateString(sysParamsVals[1]));
   mxSetField(a, 0, sysParams[3], mxCreateString(sysParamsVals[3]));
   mxSetField(a, 0, sysParams[4], mxCreateString(sysParamsVals[4]));
   mxSetField(a, 0, sysParams[5], mxCreateString(sysParamsVals[5]));
   mxSetField(a, 0, sysParams[6], mxCreateString(sysParamsVals[6]));
   mxSetField(a, 0, sysParams[7], mxCreateString(sysParamsVals[7]));
   mxSetField(a, 0, sysParams[8], mxCreateString(sysParamsVals[8]));
   mxSetField(a, 0, sysParams[9], mxCreateString(sysParamsVals[9]));
   mxSetField(a, 0, sysParams[10], mxCreateString(sysParamsVals[10]));
   mxSetField(a, 0, sysParams[11], mxCreateString(sysParamsVals[11]));
   mxSetField(a, 0, sysParams[12], mxCreateString(sysParamsVals[12]));
   mxSetField(a, 0, sysParams[13], mxCreateString(sysParamsVals[13]));
   mxSetField(a, 0, sysParams[14], mxCreateString(sysParamsVals[14]));
   mxSetField(a, 0, sysParams[15], mxCreateString(sysParamsVals[15]));
   mxSetField(a, 0, sysParams[17], mxCreateString(sysParamsVals[17]));
   mxSetField(a, 0, sysParams[18], mxCreateString(sysParamsVals[18]));
   mxSetField(a, 0, sysParams[19], mxCreateString(sysParamsVals[19]));
   mxSetField(a, 0, sysParams[20], mxCreateString(sysParamsVals[20]));
   mxSetField(a, 0, sysParams[21], mxCreateString(sysParamsVals[21]));
   mxSetField(a, 0, sysParams[22], mxCreateString(sysParamsVals[22]));
   mxSetField(a, 0, sysParams[23], mxCreateString(sysParamsVals[23]));
   mxSetField(a, 0, sysParams[24], mxCreateString(sysParamsVals[24]));
   mxSetField(a, 0, sysParams[25], mxCreateString(sysParamsVals[25]));
   mxSetField(a, 0, sysParams[26], mxCreateString(sysParamsVals[26]));
   mxSetField(a, 0, sysParams[27], mxCreateString(sysParamsVals[27]));
   mxSetField(a, 0, sysParams[28], mxCreateString(sysParamsVals[28]));
   mxSetField(a, 0, sysParams[29], mxCreateString(sysParamsVals[29]));

   return a;
}

class MLITutGRunsetA
{
public:

   // Run variables
   int  rand_index;
   int  gain_index;
   float  gain_values[2];
   Array<float> gain_values_array;
   char*  mapfiles;
   float  alpha;
   int  nscreen;
   float  hPlatform;
   float  hTarget;
   float  target_range;

   // Parameters
   float  tel_focus_range;
   float  tel_diam;
   float  hel_wavelength;
   float  ptsc_wavelength;
   float  targ_wavelength;
   float  ptsc_x;
   float  ptsc_y;
   AcsAtmSpec  AtmSpec;
   int  AtmSeed;
   float  x_wind;
   float  y_wind;
   int  propnxy;
   float  propdxy;
   int  tbd_nxy;
   float  tbd_dxy;
   int  img_nxy;
   float  img_dxy;
   float  bsm_timeConstant;
   float  trk_gain;
   int  num_speck;
   int  SpeckSeed;
   Grid<float>&  reflectance;

   // External Inputs

   // Member functions
   MLITutGRunsetA(mxArray* mliparams,
                   int  _rand_index,
                   int  _gain_index,
                   Array<float>  _gain_values_array,
                   char*  _mapfiles,
                   float  _alpha,
                   int  _nscreen,
                   float  _hPlatform,
                   float  _hTarget,
                   float  _target_range,
                   float  _tel_focus_range,
                   float  _tel_diam,
                   float  _hel_wavelength,
                   float  _ptsc_wavelength,
                   float  _targ_wavelength,
                   float  _ptsc_x,
                   float  _ptsc_y,
                   AcsAtmSpec  _AtmSpec,
                   int  _AtmSeed,
                   float  _x_wind,
                   float  _y_wind,
                   int  _propnxy,
                   float  _propdxy,
                   int  _tbd_nxy,
                   float  _tbd_dxy,
                   int  _img_nxy,
                   float  _img_dxy,
                   float  _bsm_timeConstant,
                   float  _trk_gain,
                   int  _num_speck,
                   int  _SpeckSeed,
                   Grid<float>&  _reflectance) :
                   rand_index(_rand_index),
                   gain_index(_gain_index),
                   gain_values_array(_gain_values_array),
                   mapfiles(_mapfiles),
                   alpha(_alpha),
                   nscreen(_nscreen),
                   hPlatform(_hPlatform),
                   hTarget(_hTarget),
                   target_range(_target_range),
                   tel_focus_range(_tel_focus_range),
                   tel_diam(_tel_diam),
                   hel_wavelength(_hel_wavelength),
                   ptsc_wavelength(_ptsc_wavelength),
                   targ_wavelength(_targ_wavelength),
                   ptsc_x(_ptsc_x),
                   ptsc_y(_ptsc_y),
                   AtmSpec(_AtmSpec),
                   AtmSeed(_AtmSeed),
                   x_wind(_x_wind),
                   y_wind(_y_wind),
                   propnxy(_propnxy),
                   propdxy(_propdxy),
                   tbd_nxy(_tbd_nxy),
                   tbd_dxy(_tbd_dxy),
                   img_nxy(_img_nxy),
                   img_dxy(_img_dxy),
                   bsm_timeConstant(_bsm_timeConstant),
                   trk_gain(_trk_gain),
                   num_speck(_num_speck),
                   SpeckSeed(_SpeckSeed),
                   reflectance(_reflectance)
   {
      for(int mli_gain_values_0 = 0; mli_gain_values_0 < 2; mli_gain_values_0++)
         gain_values[mli_gain_values_0] = _gain_values_array(mli_gain_values_0);

   }
   ~MLITutGRunsetA()
   {
      delete [] mapfiles;
   }
   MLISystemHandle* createSystem(mxArray* filename, mxArray* verbose)
   {
      mxArray* mlia = NULL;

      double stopTime = 0.010;

      bool verb = _mliGetVerbose(verbose);
      char *trffile;
#ifndef NO_TEMPUS_SMF_MONITOR
      char *smfile;
      TempusStatusSMFWriter* smfWriter = mliCreateSMF(filename, &trffile, &smfile);
#else
      mliCreateTRF(filename, &trffile)
#endif
      Universe* mliuniverse = new Universe("TutG");
      TutG* mlisystem = new TutG(NULL, "TutG",
                                 tel_focus_range,
                                 tel_diam,
                                 hel_wavelength,
                                 ptsc_wavelength,
                                 targ_wavelength,
                                 ptsc_x,
                                 ptsc_y,
                                 AtmSpec,
                                 AtmSeed,
                                 x_wind,
                                 y_wind,
                                 propnxy,
                                 propdxy,
                                 tbd_nxy,
                                 tbd_dxy,
                                 img_nxy,
                                 img_dxy,
                                 bsm_timeConstant,
                                 trk_gain,
                                 num_speck,
                                 SpeckSeed,
                                 reflectance);

      // Connect external inputs
      MLISystemHandle* handle = new MLISystemHandle(mliuniverse, mlisystem, this);
      handle->SetTrfFileName(trffile);
#ifndef NO_TEMPUS_SMF_MONITOR
      handle->SetSMFFileName(smfile);
      handle->SetSMFWriter(smfWriter);
#endif
      if (handle->recorderFile == NULL) {
         writeParam(handle->pset, "stopTime", DOUBLE, &stopTime);
         writeParam(handle->pset, "rand_index", LOOP, &rand_index);
         writeParam(handle->pset, "gain_index", LOOP, &gain_index);
         writeParam(handle->pset, "gain_values_array", ARRAY_FLOAT, &gain_values_array);
         writeParam(handle->pset, "mapfiles", CHAR_STAR, mapfiles);
         writeParam(handle->pset, "alpha", FLOAT, &alpha);
         writeParam(handle->pset, "nscreen", INT, &nscreen);
         writeParam(handle->pset, "hPlatform", FLOAT, &hPlatform);
         writeParam(handle->pset, "hTarget", FLOAT, &hTarget);
         writeParam(handle->pset, "target_range", FLOAT, &target_range);
         writeParam(handle->pset, "tel_focus_range", FLOAT, &tel_focus_range);
         writeParam(handle->pset, "tel_diam", FLOAT, &tel_diam);
         writeParam(handle->pset, "hel_wavelength", FLOAT, &hel_wavelength);
         writeParam(handle->pset, "ptsc_wavelength", FLOAT, &ptsc_wavelength);
         writeParam(handle->pset, "targ_wavelength", FLOAT, &targ_wavelength);
         writeParam(handle->pset, "ptsc_x", FLOAT, &ptsc_x);
         writeParam(handle->pset, "ptsc_y", FLOAT, &ptsc_y);
         char ___AtmSpecStr[159];
         sprintf(___AtmSpecStr,"(AcsAtmSpec)  AcsAtmSpec(ptsc_wavelength,nscreen,alpha,hPlatform,hTarget,target_range)\n\0");
         writeParam(handle->pset, "AtmSpec", OTHER_TYPE, ___AtmSpecStr);
         writeParam(handle->pset, "AtmSeed", INT, &AtmSeed);
         writeParam(handle->pset, "x_wind", FLOAT, &x_wind);
         writeParam(handle->pset, "y_wind", FLOAT, &y_wind);
         writeParam(handle->pset, "propnxy", INT, &propnxy);
         writeParam(handle->pset, "propdxy", FLOAT, &propdxy);
         writeParam(handle->pset, "tbd_nxy", INT, &tbd_nxy);
         writeParam(handle->pset, "tbd_dxy", FLOAT, &tbd_dxy);
         writeParam(handle->pset, "img_nxy", INT, &img_nxy);
         writeParam(handle->pset, "img_dxy", FLOAT, &img_dxy);
         writeParam(handle->pset, "bsm_timeConstant", FLOAT, &bsm_timeConstant);
         writeParam(handle->pset, "trk_gain", FLOAT, &trk_gain);
         writeParam(handle->pset, "num_speck", INT, &num_speck);
         writeParam(handle->pset, "SpeckSeed", INT, &SpeckSeed);
         char ___reflectanceStr[89];
         sprintf(___reflectanceStr,"(Grid<float>&)  matrixLoad(mapfiles,reflectance,0,0)\n\0");
         writeParam(handle->pset, "reflectance", OTHER_TYPE, ___reflectanceStr);
         handle->OpenRecorderFile();
         if (handle->recorderFile == NULL) {
            if(verb)
               mexPrintf("Error -- Null recorder file may cause problems.\n");
         }
      }
      return(handle);
   }
};

MLITutGRunsetA* mliTutGRunsetACompParams(mxArray* mliparamsin, mxArray*& mliparamsout, mxArray* mliverbose)
{
   bool verb = _mliGetVerbose(mliverbose);
   mxArray* mlia = NULL;

   double stopTime = 0.010;

   int  rand_index = 0;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "rand_index");
   if(!_mliCheckValue(mlia, sysParamsVals[0])) fromMxArray(mlia, rand_index);

   int  gain_index = 0;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "gain_index");
   if(!_mliCheckValue(mlia, sysParamsVals[1])) fromMxArray(mlia, gain_index);

   float  gain_values[2] = {0.0,1.0};
   Array<float>  gain_values_array(2);
   for(int mli_gain_values_0 = 0; mli_gain_values_0 < 2; mli_gain_values_0++)
      gain_values_array(mli_gain_values_0) = gain_values[mli_gain_values_0];


   char*  mapfiles = new char[strlen("./targets.mat/disc50")+1];
   strcpy(mapfiles, "./targets.mat/disc50");
   mapfiles[strlen("./targets.mat/disc50")] = '\0';
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "mapfiles");
   if(!_mliCheckValue(mlia, sysParamsVals[3]))
   {
      delete [] mapfiles;
      fromMxArray(mlia, mapfiles);
   }

   float  alpha = 1.0;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "alpha");
   if(!_mliCheckValue(mlia, sysParamsVals[4])) fromMxArray(mlia, alpha);

   int  nscreen = 5;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "nscreen");
   if(!_mliCheckValue(mlia, sysParamsVals[5])) fromMxArray(mlia, nscreen);

   float  hPlatform = 2400;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "hPlatform");
   if(!_mliCheckValue(mlia, sysParamsVals[6])) fromMxArray(mlia, hPlatform);

   float  hTarget = 2400;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "hTarget");
   if(!_mliCheckValue(mlia, sysParamsVals[7])) fromMxArray(mlia, hTarget);

   float  target_range = 50000;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "target_range");
   if(!_mliCheckValue(mlia, sysParamsVals[8])) fromMxArray(mlia, target_range);

   float  tel_focus_range = target_range;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "tel_focus_range");
   if(!_mliCheckValue(mlia, sysParamsVals[9])) fromMxArray(mlia, tel_focus_range);

   float  tel_diam = 0.75;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "tel_diam");
   if(!_mliCheckValue(mlia, sysParamsVals[10])) fromMxArray(mlia, tel_diam);

   float  hel_wavelength = 1.0e-6;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "hel_wavelength");
   if(!_mliCheckValue(mlia, sysParamsVals[11])) fromMxArray(mlia, hel_wavelength);

   float  ptsc_wavelength = hel_wavelength;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "ptsc_wavelength");
   if(!_mliCheckValue(mlia, sysParamsVals[12])) fromMxArray(mlia, ptsc_wavelength);

   float  targ_wavelength = hel_wavelength+0.001e-6;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "targ_wavelength");
   if(!_mliCheckValue(mlia, sysParamsVals[13])) fromMxArray(mlia, targ_wavelength);

   float  ptsc_x = 0.0;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "ptsc_x");
   if(!_mliCheckValue(mlia, sysParamsVals[14])) fromMxArray(mlia, ptsc_x);

   float  ptsc_y = 0.0;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "ptsc_y");
   if(!_mliCheckValue(mlia, sysParamsVals[15])) fromMxArray(mlia, ptsc_y);

   AcsAtmSpec  AtmSpec = AcsAtmSpec(ptsc_wavelength,nscreen,alpha,hPlatform,hTarget,target_range);

   int  AtmSeed = seedSequence(-123456789,rand_index);
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "AtmSeed");
   if(!_mliCheckValue(mlia, sysParamsVals[17])) fromMxArray(mlia, AtmSeed);

   float  x_wind = 10.0;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "x_wind");
   if(!_mliCheckValue(mlia, sysParamsVals[18])) fromMxArray(mlia, x_wind);

   float  y_wind = 0.0;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "y_wind");
   if(!_mliCheckValue(mlia, sysParamsVals[19])) fromMxArray(mlia, y_wind);

   int  propnxy = 256;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "propnxy");
   if(!_mliCheckValue(mlia, sysParamsVals[20])) fromMxArray(mlia, propnxy);

   float  propdxy = 0.02;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "propdxy");
   if(!_mliCheckValue(mlia, sysParamsVals[21])) fromMxArray(mlia, propdxy);

   int  tbd_nxy = 100;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "tbd_nxy");
   if(!_mliCheckValue(mlia, sysParamsVals[22])) fromMxArray(mlia, tbd_nxy);

   float  tbd_dxy = 0.01;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "tbd_dxy");
   if(!_mliCheckValue(mlia, sysParamsVals[23])) fromMxArray(mlia, tbd_dxy);

   int  img_nxy = 100;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "img_nxy");
   if(!_mliCheckValue(mlia, sysParamsVals[24])) fromMxArray(mlia, img_nxy);

   float  img_dxy = tbd_dxy/target_range;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "img_dxy");
   if(!_mliCheckValue(mlia, sysParamsVals[25])) fromMxArray(mlia, img_dxy);

   float  bsm_timeConstant = 1.0e-6;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "bsm_timeConstant");
   if(!_mliCheckValue(mlia, sysParamsVals[26])) fromMxArray(mlia, bsm_timeConstant);

   float  trk_gain = gain_values[gain_index];
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "trk_gain");
   if(!_mliCheckValue(mlia, sysParamsVals[27])) fromMxArray(mlia, trk_gain);

   int  num_speck = 8;
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "num_speck");
   if(!_mliCheckValue(mlia, sysParamsVals[28])) fromMxArray(mlia, num_speck);

   int  SpeckSeed = seedSequence(-123456789+100000,rand_index);
   if(mliparamsin) mlia = mxGetField(mliparamsin, 0, "SpeckSeed");
   if(!_mliCheckValue(mlia, sysParamsVals[29])) fromMxArray(mlia, SpeckSeed);

   Grid<float>&  reflectance = matrixLoad(mapfiles,reflectance,0,0);

   mliparamsout = mxCreateStructMatrix(1, 1, numParams, sysParams);

   mxSetField(mliparamsout, 0, "rand_index", toMxArray(rand_index));
   mxSetField(mliparamsout, 0, "gain_index", toMxArray(gain_index));
   mxSetField(mliparamsout, 0, "gain_values_array", toMxArray(gain_values_array));
   mxSetField(mliparamsout, 0, "mapfiles", mxCreateString(mapfiles));
   mxSetField(mliparamsout, 0, "alpha", toMxArray(alpha));
   mxSetField(mliparamsout, 0, "nscreen", toMxArray(nscreen));
   mxSetField(mliparamsout, 0, "hPlatform", toMxArray(hPlatform));
   mxSetField(mliparamsout, 0, "hTarget", toMxArray(hTarget));
   mxSetField(mliparamsout, 0, "target_range", toMxArray(target_range));
   mxSetField(mliparamsout, 0, "tel_focus_range", toMxArray(tel_focus_range));
   mxSetField(mliparamsout, 0, "tel_diam", toMxArray(tel_diam));
   mxSetField(mliparamsout, 0, "hel_wavelength", toMxArray(hel_wavelength));
   mxSetField(mliparamsout, 0, "ptsc_wavelength", toMxArray(ptsc_wavelength));
   mxSetField(mliparamsout, 0, "targ_wavelength", toMxArray(targ_wavelength));
   mxSetField(mliparamsout, 0, "ptsc_x", toMxArray(ptsc_x));
   mxSetField(mliparamsout, 0, "ptsc_y", toMxArray(ptsc_y));
   mxSetField(mliparamsout, 0, "AtmSeed", toMxArray(AtmSeed));
   mxSetField(mliparamsout, 0, "x_wind", toMxArray(x_wind));
   mxSetField(mliparamsout, 0, "y_wind", toMxArray(y_wind));
   mxSetField(mliparamsout, 0, "propnxy", toMxArray(propnxy));
   mxSetField(mliparamsout, 0, "propdxy", toMxArray(propdxy));
   mxSetField(mliparamsout, 0, "tbd_nxy", toMxArray(tbd_nxy));
   mxSetField(mliparamsout, 0, "tbd_dxy", toMxArray(tbd_dxy));
   mxSetField(mliparamsout, 0, "img_nxy", toMxArray(img_nxy));
   mxSetField(mliparamsout, 0, "img_dxy", toMxArray(img_dxy));
   mxSetField(mliparamsout, 0, "bsm_timeConstant", toMxArray(bsm_timeConstant));
   mxSetField(mliparamsout, 0, "trk_gain", toMxArray(trk_gain));
   mxSetField(mliparamsout, 0, "num_speck", toMxArray(num_speck));
   mxSetField(mliparamsout, 0, "SpeckSeed", toMxArray(SpeckSeed));

   return(new MLITutGRunsetA(mliparamsout,
                             rand_index,
                             gain_index,
                             gain_values_array,
                             mapfiles,
                             alpha,
                             nscreen,
                             hPlatform,
                             hTarget,
                             target_range,
                             tel_focus_range,
                             tel_diam,
                             hel_wavelength,
                             ptsc_wavelength,
                             targ_wavelength,
                             ptsc_x,
                             ptsc_y,
                             AtmSpec,
                             AtmSeed,
                             x_wind,
                             y_wind,
                             propnxy,
                             propdxy,
                             tbd_nxy,
                             tbd_dxy,
                             img_nxy,
                             img_dxy,
                             bsm_timeConstant,
                             trk_gain,
                             num_speck,
                             SpeckSeed,
                             reflectance));
}
mxArray* mliCompParams(mxArray* paramsin, mxArray* verbose)
{
   mxArray* paramsout;
   MLITutGRunsetA* tmpcls = mliTutGRunsetACompParams(paramsin, paramsout, verbose);
   delete tmpcls;
   return paramsout;
}

mxArray* mliCreateSystem(mxArray* paramsin, mxArray* filename, mxArray* verbose)
{
   mxArray* paramsout;
   mxArray* runhandle;
   MLITutGRunsetA* tmpcls = mliTutGRunsetACompParams(paramsin, paramsout, verbose);
   MLISystemHandle* handle = tmpcls->createSystem(filename, verbose);
   runhandle = mliMakePointer(handle);
   return(runhandle);
}

mxArray* mliRecordOutputs(mxArray* mhandle,  mxArray* outputs,
                          mxArray* mstatus,  mxArray* matLeast,  mxArray* mexactly,
                          mxArray* verbose)
{
   if (!_mliVerifyOutputs(outputs)) {
      mexPrintf("Outputs should be a list of structures.\n");
      return mhandle;
   }
   bool verb = _mliGetVerbose(verbose);
   mxClassID outType = mxGetClassID(outputs);
   int nOutputs = 0;
   char outstr[256] = "";
   mxArray* cname = outputs;
   bool   status      = true;
   float  atLeastRate = 0.0;
   double exactlyRate = 0.0;

   MLISystemHandle* handle = reinterpret_cast<MLISystemHandle*>(mliGetPointer(mhandle));
   TutG* system = reinterpret_cast<TutG*>(handle->system);

   if(outType == mxCELL_CLASS)
      nOutputs = mxGetN(outputs);
   else nOutputs = 1;

   handle->NewRecorders(nOutputs);

   for (int ic = 0; ic < nOutputs; ic++) 
   {
      atLeastRate = mxGetPr(matLeast)[ic];
      exactlyRate = mxGetPr(mexactly)[ic];
      status      = mxGetPr(mstatus) [ic] > 0.0;
      if (outType == mxCELL_CLASS) cname = mxGetCell(outputs, ic); 

      if (mxGetString(cname, outstr, 256) != 0) {
         mexPrintf("Error -- Not a string.\n");
      }
      if(strcmp(outstr, "targetboard.integrated_intensity") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         GridRecorder<float>*  rfsetA1 = new GridRecorder<float>(NULL, "rfsetA1", "targetboard.integrated_intensity", "Grid<float>", "Integrated intensity", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA1->dr <<= handle->recorderFile->dr;
         rfsetA1->i <<= system->targetboard.integrated_intensity;
         handle->AddRecorder(rfsetA1);
      }
      if(strcmp(outstr, "uw.power") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         floatRecorder*  rfsetA2 = new floatRecorder(NULL, "rfsetA2", "uw.power", "float", "Total power (W)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA2->dr <<= handle->recorderFile->dr;
         rfsetA2->i <<= system->uw.power;
         handle->AddRecorder(rfsetA2);
      }
      if(strcmp(outstr, "trk_camera.fpaImage") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         GridRecorder<float>*  rfsetA3 = new GridRecorder<float>(NULL, "rfsetA3", "trk_camera.fpaImage", "Grid<float>", "the image formed at focal plane, integrated over each exposure interval", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA3->dr <<= handle->recorderFile->dr;
         rfsetA3->i <<= system->trk_camera.fpaImage;
         handle->AddRecorder(rfsetA3);
      }
      if(strcmp(outstr, "BSM.measuredTilts") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         VectorRecorder<float>*  rfsetA4 = new VectorRecorder<float>(NULL, "rfsetA4", "BSM.measuredTilts", "Vector<float>", "measured tilts (radians) (from an ideal pickoff sensor)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA4->dr <<= handle->recorderFile->dr;
         rfsetA4->i <<= system->BSM.measuredTilts;
         handle->AddRecorder(rfsetA4);
      }
      if(strcmp(outstr, "BSM.delay.delayedScalar") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         floatRecorder*  rfsetA5 = new floatRecorder(NULL, "rfsetA5", "BSM.delay.delayedScalar", "float", "equal to scalar input, but delayed by specified amount", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA5->dr <<= handle->recorderFile->dr;
         rfsetA5->i <<= system->BSM.delay.delayedScalar;
         handle->AddRecorder(rfsetA5);
      }
      if(strcmp(outstr, "BSM.delay.delayedVector") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         VectorRecorder<float>*  rfsetA6 = new VectorRecorder<float>(NULL, "rfsetA6", "BSM.delay.delayedVector", "Vector<float>", "equal to vector input, but delayed by specified amount", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA6->dr <<= handle->recorderFile->dr;
         rfsetA6->i <<= system->BSM.delay.delayedVector;
         handle->AddRecorder(rfsetA6);
      }
      if(strcmp(outstr, "trk_centroid.x") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         floatRecorder*  rfsetA7 = new floatRecorder(NULL, "rfsetA7", "trk_centroid.x", "float", "X-coordinate of centroid (m)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA7->dr <<= handle->recorderFile->dr;
         rfsetA7->i <<= system->trk_centroid.x;
         handle->AddRecorder(rfsetA7);
      }
      if(strcmp(outstr, "trk_centroid.y") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         floatRecorder*  rfsetA8 = new floatRecorder(NULL, "rfsetA8", "trk_centroid.y", "float", "Y-coordinate of centroid (m)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA8->dr <<= handle->recorderFile->dr;
         rfsetA8->i <<= system->trk_centroid.y;
         handle->AddRecorder(rfsetA8);
      }
      if(strcmp(outstr, "trk_centroid.v") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         VectorRecorder<float>*  rfsetA9 = new VectorRecorder<float>(NULL, "rfsetA9", "trk_centroid.v", "Vector<float>", "X and Y coordinates of centroid (m)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA9->dr <<= handle->recorderFile->dr;
         rfsetA9->i <<= system->trk_centroid.v;
         handle->AddRecorder(rfsetA9);
      }
      if(strcmp(outstr, "summer.sum") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         VectorRecorder<float>*  rfsetA10 = new VectorRecorder<float>(NULL, "rfsetA10", "summer.sum", "Vector<float>", "weighted sum of the two input vectors, recomputed only when the first input vector changes", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA10->dr <<= handle->recorderFile->dr;
         rfsetA10->i <<= system->summer.sum;
         handle->AddRecorder(rfsetA10);
      }
      if(strcmp(outstr, "img_camera.fpaImage") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         GridRecorder<float>*  rfsetA11 = new GridRecorder<float>(NULL, "rfsetA11", "img_camera.fpaImage", "Grid<float>", "the image formed at focal plane, integrated over each exposure interval", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA11->dr <<= handle->recorderFile->dr;
         rfsetA11->i <<= system->img_camera.fpaImage;
         handle->AddRecorder(rfsetA11);
      }
      if(strcmp(outstr, "incoherentreflector.illumination") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         GridRecorder<float>*  rfsetA12 = new GridRecorder<float>(NULL, "rfsetA12", "incoherentreflector.illumination", "Grid<float>", "intensity pattern of the incident illumination (W/m^2)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA12->dr <<= handle->recorderFile->dr;
         rfsetA12->i <<= system->incoherentreflector.illumination;
         handle->AddRecorder(rfsetA12);
      }
      if(strcmp(outstr, "incoherentreflector.signature") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         GridRecorder<float>*  rfsetA13 = new GridRecorder<float>(NULL, "rfsetA13", "incoherentreflector.signature", "Grid<float>", "intensity pattern of the reflected return (W/m^2)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA13->dr <<= handle->recorderFile->dr;
         rfsetA13->i <<= system->incoherentreflector.signature;
         handle->AddRecorder(rfsetA13);
      }
      if(strcmp(outstr, "uw2.power") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         floatRecorder*  rfsetA14 = new floatRecorder(NULL, "rfsetA14", "uw2.power", "float", "Total power (W)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA14->dr <<= handle->recorderFile->dr;
         rfsetA14->i <<= system->uw2.power;
         handle->AddRecorder(rfsetA14);
      }
      if(strcmp(outstr, "img_centroid.x") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         floatRecorder*  rfsetA15 = new floatRecorder(NULL, "rfsetA15", "img_centroid.x", "float", "X-coordinate of centroid (m)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA15->dr <<= handle->recorderFile->dr;
         rfsetA15->i <<= system->img_centroid.x;
         handle->AddRecorder(rfsetA15);
      }
      if(strcmp(outstr, "img_centroid.y") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         floatRecorder*  rfsetA16 = new floatRecorder(NULL, "rfsetA16", "img_centroid.y", "float", "Y-coordinate of centroid (m)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA16->dr <<= handle->recorderFile->dr;
         rfsetA16->i <<= system->img_centroid.y;
         handle->AddRecorder(rfsetA16);
      }
      if(strcmp(outstr, "img_centroid.v") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         VectorRecorder<float>*  rfsetA17 = new VectorRecorder<float>(NULL, "rfsetA17", "img_centroid.v", "Vector<float>", "X and Y coordinates of centroid (m)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA17->dr <<= handle->recorderFile->dr;
         rfsetA17->i <<= system->img_centroid.v;
         handle->AddRecorder(rfsetA17);
      }
      if(strcmp(outstr, "tbd_centroid.x") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         floatRecorder*  rfsetA18 = new floatRecorder(NULL, "rfsetA18", "tbd_centroid.x", "float", "X-coordinate of centroid (m)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA18->dr <<= handle->recorderFile->dr;
         rfsetA18->i <<= system->tbd_centroid.x;
         handle->AddRecorder(rfsetA18);
      }
      if(strcmp(outstr, "tbd_centroid.y") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         floatRecorder*  rfsetA19 = new floatRecorder(NULL, "rfsetA19", "tbd_centroid.y", "float", "Y-coordinate of centroid (m)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA19->dr <<= handle->recorderFile->dr;
         rfsetA19->i <<= system->tbd_centroid.y;
         handle->AddRecorder(rfsetA19);
      }
      if(strcmp(outstr, "tbd_centroid.v") == 0) {
         if(verb) mexPrintf("Creating recorder %s\n", outstr);

         VectorRecorder<float>*  rfsetA20 = new VectorRecorder<float>(NULL, "rfsetA20", "tbd_centroid.v", "Vector<float>", "X and Y coordinates of centroid (m)", status, atLeastRate, exactlyRate);
         if(handle->recorderFile != NULL)
            rfsetA20->dr <<= handle->recorderFile->dr;
         rfsetA20->i <<= system->tbd_centroid.v;
         handle->AddRecorder(rfsetA20);
      }
      if (verb) mexPrintf("Output %s not found.\n", outstr);
   }

   return mhandle;
}

mxArray* mliStopRecOutputs(mxArray* mhandle, mxArray* outputs, mxArray* verbose)
{
   if (!_mliVerifyOutputs(outputs)) {
      mexPrintf("Outputs should be a list of structures.\n");
      return mhandle;
   }  
   bool verb = _mliGetVerbose(verbose);
   int       nOutputs = mxGetN(outputs);
   mxClassID outType  = mxGetClassID(outputs);
   char      outstr[256] = "";
   mxArray*  cname = outputs;
   MLISystemHandle* handle = reinterpret_cast<MLISystemHandle*>(mliGetPointer(mhandle));
   for (int ic = 0; ic < nOutputs; ic++) 
   {
      RecordableObject* recobj = NULL;
      if (outType == mxCELL_CLASS) cname = mxGetCell(outputs, ic);
      if (mxGetString(cname, outstr, 256) == 0) 
          recobj = handle->RemoveRecorder(outstr);  
      if (recobj == NULL) {
         if (verb) mexPrintf("Cannot find recorder %s.\n", outstr);
         continue;
      }
      if(strcmp(outstr, "targetboard.integrated_intensity") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         GridRecorder<float>*  rfsetA1= (GridRecorder<float>*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA1->i.detach();
      }
      if(strcmp(outstr, "uw.power") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         floatRecorder*  rfsetA2= (floatRecorder*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA2->i.detach();
      }
      if(strcmp(outstr, "trk_camera.fpaImage") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         GridRecorder<float>*  rfsetA3= (GridRecorder<float>*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA3->i.detach();
      }
      if(strcmp(outstr, "BSM.measuredTilts") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         VectorRecorder<float>*  rfsetA4= (VectorRecorder<float>*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA4->i.detach();
      }
      if(strcmp(outstr, "BSM.delay.delayedScalar") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         floatRecorder*  rfsetA5= (floatRecorder*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA5->i.detach();
      }
      if(strcmp(outstr, "BSM.delay.delayedVector") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         VectorRecorder<float>*  rfsetA6= (VectorRecorder<float>*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA6->i.detach();
      }
      if(strcmp(outstr, "trk_centroid.x") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         floatRecorder*  rfsetA7= (floatRecorder*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA7->i.detach();
      }
      if(strcmp(outstr, "trk_centroid.y") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         floatRecorder*  rfsetA8= (floatRecorder*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA8->i.detach();
      }
      if(strcmp(outstr, "trk_centroid.v") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         VectorRecorder<float>*  rfsetA9= (VectorRecorder<float>*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA9->i.detach();
      }
      if(strcmp(outstr, "summer.sum") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         VectorRecorder<float>*  rfsetA10= (VectorRecorder<float>*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA10->i.detach();
      }
      if(strcmp(outstr, "img_camera.fpaImage") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         GridRecorder<float>*  rfsetA11= (GridRecorder<float>*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA11->i.detach();
      }
      if(strcmp(outstr, "incoherentreflector.illumination") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         GridRecorder<float>*  rfsetA12= (GridRecorder<float>*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA12->i.detach();
      }
      if(strcmp(outstr, "incoherentreflector.signature") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         GridRecorder<float>*  rfsetA13= (GridRecorder<float>*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA13->i.detach();
      }
      if(strcmp(outstr, "uw2.power") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         floatRecorder*  rfsetA14= (floatRecorder*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA14->i.detach();
      }
      if(strcmp(outstr, "img_centroid.x") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         floatRecorder*  rfsetA15= (floatRecorder*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA15->i.detach();
      }
      if(strcmp(outstr, "img_centroid.y") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         floatRecorder*  rfsetA16= (floatRecorder*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA16->i.detach();
      }
      if(strcmp(outstr, "img_centroid.v") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         VectorRecorder<float>*  rfsetA17= (VectorRecorder<float>*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA17->i.detach();
      }
      if(strcmp(outstr, "tbd_centroid.x") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         floatRecorder*  rfsetA18= (floatRecorder*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA18->i.detach();
      }
      if(strcmp(outstr, "tbd_centroid.y") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         floatRecorder*  rfsetA19= (floatRecorder*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA19->i.detach();
      }
      if(strcmp(outstr, "tbd_centroid.v") == 0) {
         if(verb) mexPrintf("Detaching recorder %s\n", outstr);

         VectorRecorder<float>*  rfsetA20= (VectorRecorder<float>*)reinterpret_cast< RecordableObject* >(recobj);
           rfsetA20->i.detach();
      }
   }
   return mhandle;
}

mxArray* mliGetOutput(mxArray* mhandle, mxArray* output, mxArray* verbose)
{
   bool verb = _mliGetVerbose(verbose);
   MLISystemHandle* handle = reinterpret_cast<MLISystemHandle*>(mliGetPointer(mhandle));
   TutG* system = reinterpret_cast<TutG*>(handle->system);
   char outstr[256] = "";
   if (mxGetString(output, outstr, 256) != 0) {
      mexPrintf("Output name should be a string.\n");
   }  
   if(strcmp(outstr, "targetboard.integrated_intensity") == 0) {
      return toMxArray(system->targetboard.integrated_intensity.value());
   }
   if(strcmp(outstr, "uw.power") == 0) {
      return toMxArray(system->uw.power.value());
   }
   if(strcmp(outstr, "trk_camera.fpaImage") == 0) {
      return toMxArray(system->trk_camera.fpaImage.value());
   }
   if(strcmp(outstr, "BSM.measuredTilts") == 0) {
      return toMxArray(system->BSM.measuredTilts.value());
   }
   if(strcmp(outstr, "BSM.delay.delayedScalar") == 0) {
      return toMxArray(system->BSM.delay.delayedScalar.value());
   }
   if(strcmp(outstr, "BSM.delay.delayedVector") == 0) {
      return toMxArray(system->BSM.delay.delayedVector.value());
   }
   if(strcmp(outstr, "trk_centroid.x") == 0) {
      return toMxArray(system->trk_centroid.x.value());
   }
   if(strcmp(outstr, "trk_centroid.y") == 0) {
      return toMxArray(system->trk_centroid.y.value());
   }
   if(strcmp(outstr, "trk_centroid.v") == 0) {
      return toMxArray(system->trk_centroid.v.value());
   }
   if(strcmp(outstr, "summer.sum") == 0) {
      return toMxArray(system->summer.sum.value());
   }
   if(strcmp(outstr, "img_camera.fpaImage") == 0) {
      return toMxArray(system->img_camera.fpaImage.value());
   }
   if(strcmp(outstr, "incoherentreflector.illumination") == 0) {
      return toMxArray(system->incoherentreflector.illumination.value());
   }
   if(strcmp(outstr, "incoherentreflector.signature") == 0) {
      return toMxArray(system->incoherentreflector.signature.value());
   }
   if(strcmp(outstr, "uw2.power") == 0) {
      return toMxArray(system->uw2.power.value());
   }
   if(strcmp(outstr, "img_centroid.x") == 0) {
      return toMxArray(system->img_centroid.x.value());
   }
   if(strcmp(outstr, "img_centroid.y") == 0) {
      return toMxArray(system->img_centroid.y.value());
   }
   if(strcmp(outstr, "img_centroid.v") == 0) {
      return toMxArray(system->img_centroid.v.value());
   }
   if(strcmp(outstr, "tbd_centroid.x") == 0) {
      return toMxArray(system->tbd_centroid.x.value());
   }
   if(strcmp(outstr, "tbd_centroid.y") == 0) {
      return toMxArray(system->tbd_centroid.y.value());
   }
   if(strcmp(outstr, "tbd_centroid.v") == 0) {
      return toMxArray(system->tbd_centroid.v.value());
   }
   mexPrintf("Output %s not found.\n", outstr);
   return toMxArray(0);
}
mxArray* mliSetInputs(mxArray* mhandle, mxArray* inputs, mxArray* values, mxArray* verbose)
{
   bool verb = _mliGetVerbose(verbose);
   mxClassID inType = mxGetClassID(inputs);
   mxClassID valType = mxGetClassID(values);
   int nInputs = 0;
   char instr[256] = "";
   mxArray* cname = inputs;
   mxArray* val = values;
   
   MLISystemHandle* handle = reinterpret_cast<MLISystemHandle*>(mliGetPointer(mhandle));
   MLITutGRunsetA* runset = reinterpret_cast<MLITutGRunsetA*>(handle->parameters);
   
   if(inType == mxCELL_CLASS) nInputs = mxGetN(inputs);
   else nInputs = 1;

   for(int ic = 0; ic < nInputs; ic++)
   {
      if(inType == mxCELL_CLASS) cname = mxGetCell(inputs, ic);
      if(valType == mxCELL_CLASS) val = mxGetCell(values, ic);
      
      if(mxGetString(cname, instr, 256) != 0) mexPrintf("Error -- Not a string.\n");

   }
   return mhandle;
}
